
import kareltherobot.FelKarel;
import kareltherobot.UrRobot;
import kareltherobot.Directions;
import kareltherobot.World;

public class DemoKarel extends FelKarel {

   public void start() {
      World.setVisible(true);
      World.readWorld("maze.klwd");
      World.setDelay(5);

      setRobot(new UrRobot(3, 2, Directions.North, 0));
      execute();
   }

   void turnAround() {
      turnLeft();
      turnLeft();
   }

   void turnRight() {
      for (int i = 0; i < 3; i++) {
         turnLeft();
      }
   }

   boolean isWallOnRight() {
      turnRight();
      boolean out = isInFrontOfWall();
      turnLeft();
      return out;
   }

   void go() {
      if (isOnBeeper()) {
         pickBeeper();
         turnAround();
         return;
      }
      int numberTurnRight = 0;
      if (!isWallOnRight()) {
         turnRight();
         numberTurnRight++;
      }

      while (isInFrontOfWall()) {
         turnLeft();
         numberTurnRight--;
      }
      move(); //move forward
      go();
      move(); //move backward 

      numberTurnRight = (numberTurnRight + 4) % 4;
      for (int i = 0; i < numberTurnRight; ++i) {
         turnLeft(); //revert the turns
      }
   }

   public void execute() {
      go();
      putBeeper();
      turnOff();
   }

   public static void main(String[] args) {
      DemoKarel demo = new DemoKarel();
      demo.start();
   }
}
