public class DemoFibonacci {

   long counter;

   long fibonnaciRecursive(int n) {
      counter++;
      return n < 2 ? 1l : fibonnaciRecursive(n - 1) + fibonnaciRecursive(n - 2);
   }

   long fibonnaciIterative(int n) {
      long fibM2 = 1l;
      long fibM1 = 1l;
      long fib = 1l;
      for (int i = 2; i <= n; ++i) {
         fibM2 = fibM1;
         fibM1 = fib;
         fib = fibM1 + fibM2;
         counter += 3;
      }
      return fib;
   }

   public void start(String[] args) {
      int n = args.length > 0 ? Integer.parseInt(args[0]) : 25;
      counter = 0;
      long fibR = fibonnaciRecursive(n);
      long counterR = counter;

      counter = 0;
      long fibI = fibonnaciIterative(n);
      long counterI = counter;

      System.out.println("Fibonacci number recursive: " + fibR);
      System.out.println("Fibonacci number iteration: " + fibI);
      System.out.println("Counter recursive: " + counterR);
      System.out.println("Counter iteration: " + counterI);
   }

   public static void main(String[] args) {
      DemoFibonacci demo = new DemoFibonacci();
      demo.start(args);
   }
} 
