public class DemoFibonacciStats {

   long counter;

   long fibonnaciRecursive(int n) {
      counter++;
      return n < 2 ? 1l : fibonnaciRecursive(n - 1) + fibonnaciRecursive(n - 2);
   }

   long fibonnaciIterative(int n) {
      long fibM2 = 1l;
      long fibM1 = 1l;
      long fib = 1l;
      for (int i = 2; i <= n; ++i) {
         fibM2 = fibM1;
         fibM1 = fib;
         fib = fibM1 + fibM2;
         counter += 3;
      }
      return fib;
   }

   public void start(String[] args) {
      int m = args.length > 0 ? Integer.parseInt(args[0]) : 45;
      for (int n = 0; n < m; ++n) {
	 counter = 0;
	 long fibR = fibonnaciRecursive(n);
	 long counterR = counter;

	 counter = 0;
	 long fibI = fibonnaciIterative(n);
	 long counterI = counter;
	 System.out.format("%d\t%6.3e\t%6.3e\n", n, (double)counterR, (double)counterI);
      }
   }

   public static void main(String[] args) {
      DemoFibonacciStats demo = new DemoFibonacciStats();
      demo.start(args);
   }
} 
