public class DemoTowersOfHanoi {

   void moveTower(int n, int from, int to, int tmp) {
      if (n > 0) {
         moveTower(n-1, from, tmp, to); //move to tmp
         System.out.println("Move disc from " + from + " to " + to);
         moveTower(n-1, tmp, to, from); //move from tmp
      }
   }

   public void start(int numberOfDiscs) {
      moveTower(numberOfDiscs, 1, 2, 3);
   }

   public static void main(String[] args) {
      DemoTowersOfHanoi hanoi = new DemoTowersOfHanoi();
      hanoi.start(args.length > 0 ? Integer.parseInt(args[0]) : 3);
   }

} 
